Package: ppcSpatial
Type: Package
Title: Spatial Analysis of Pakistan Population Census
Version: 0.3.0
Authors@R: c(
              person(c("Muhammad", "Yaseen"),  email = "myaseen208@gmail.com", role = c("aut", "cre"))
            , person(c("Muhammad", "Arfan", "Dilber"),  email = "pbsfsd041@gmail.com", role = c("aut", "ctb"))
            )
Maintainer: Muhammad Yaseen <myaseen208@gmail.com>
Description: Spatial Analysis for exploration of Pakistan Population Census 2017 (<https://www.pbs.gov.pk/content/population-census>). It uses data from R package 'PakPC2017'.
Depends: R (>= 3.1)
Imports: dplyr, ggplot2, htmltools, htmlwidgets, leaflet, magrittr,
        PakPC2017, scales, shiny, tidyr, tmap
Suggests: testthat
License: GPL-3
URL: https://github.com/MYaseen208/ppcSpatial
RoxygenNote: 7.2.3
NeedsCompilation: no
Packaged: 2023-04-29 06:59:41 UTC; hp
Author: Muhammad Yaseen [aut, cre],
  Muhammad Arfan Dilber [aut, ctb]
Repository: CRAN
Date/Publication: 2023-04-29 07:20:02 UTC
Built: R 4.6.0; ; 2026-04-25 13:16:37 UTC; unix

#' @title Visualization of all provinces.
#' @name plotProvinces
#' @description Visualization of all provinces from shiny app.
#' @keywords internal
#' @return Return ggplot of all provinces.

if(getRversion() >= "2.15.1"){
  utils::globalVariables(
    c(
      "Census"
      , "City"
      , "District"
      , "Division"
      , "Pop1998"
      , "Pop2017"
      , "Population"
      , "Province"
      , "Tehsil"
    )
  )
}

plotProvinces <- function() {
    plotUnit <-
      PakPC2017::PakPC2017Tehsil %>%
      dplyr::group_by(Province) %>%
      dplyr::summarize(
          Pop2017 = sum(Pop2017, na.rm = TRUE)
        , Pop1998 = sum(Pop1998, na.rm = TRUE)
      ) %>%
      tidyr::gather(
        key   = "Census"
        , value = "Population"
        , -Province
      )

    ggplot(
      data = plotUnit
      , mapping = aes(x = reorder(Province, -Population), y = Population, fill = Census)) +
      geom_bar(stat = "identity", position = position_dodge(width = 0.9))+
      scale_y_continuous(labels= scales::comma, expand =  c(0, 0)) +
      scale_x_discrete(expand = c(0.03,0))+
      geom_text(aes(label=scales::comma(Population)),
                position=position_dodge(width = 0.9), vjust = 0.8) +
      labs(x = "Provinces") +
      theme(legend.position = "top")


  }

#' @title Visualization of all top cities.
#' @name plotCity
#' @description Visualization of all top cities from shiny app.
#' @keywords internal
#' @return Return ggplot of all top cities.

if(getRversion() >= "2.15.1"){
  utils::globalVariables(
    c(
      "Census"
      , "City"
      , "District"
      , "Division"
      , "Pop1998"
      , "Pop2017"
      , "Population"
      , "Province"
      , "Tehsil"
    )
  )
}

plotCity <- function() {
  plotUnit <-
    PakPC2017::PakPC2017City10 %>%
    arrange(desc(Pop2017)) %>%
    tidyr::gather(
      key   = "Census"
      , value = "Population"
      , -City
    )


  plotOut<-ggplot(
    data = plotUnit
    , mapping = aes(x = reorder(City, -Population), y = Population, fill = Census)) +
    geom_bar(stat = "identity", position = position_dodge(width = .9))+
    scale_y_continuous(labels= scales::comma,expand =  c(0,0)) +
    scale_x_discrete(expand = c(0.03,0))+
    geom_text(aes(label=scales::comma(Population)),
              position=position_dodge(width = 0.9), vjust = 0.8) +
    labs(x = "Cities") +
    theme(legend.position = "top")
return(plotOut)
}

library(dplyr)
library(ggplot2)
library(htmltools)
library(htmlwidgets)
library(leaflet)
library(magrittr)
library(PakPC2017)
library(rgdal)
library(scales)
library(shiny)
library(testthat)
library(tidyr)
library(tmap)


source("tableOut.R")
source("plotProvinces.R")
source("plotDivisions.R")
source("plotDistricts.R")
source("plotTehsils.R")
source("plotCity.R")

#' @title Visualization of selected divisions.
#' @name plotDivisions
#' @description Visualization of selected divisions from shiny app.
#' @param filterTehsil The selected divisions for which plot to be build.
#' @keywords internal
#' @return Return ggplot of selected divisions.

if(getRversion() >= "2.15.1"){
  utils::globalVariables(
    c(
      "Census"
      , "City"
      , "District"
      , "Division"
      , "Pop1998"
      , "Pop2017"
      , "Population"
      , "Province"
      , "Tehsil"
    )
  )
}

plotDivisions <- function(filterDivision) {
plotUnit <-
  PakPC2017::PakPC2017Tehsil %>%
  dplyr::group_by(Province, Division) %>%
  dplyr::summarize(
    Pop2017 = sum(Pop2017, na.rm = TRUE)
    , Pop1998 = sum(Pop1998, na.rm = TRUE)
  ) %>%
  dplyr::filter(Division %in% filterDivision) %>%
  tidyr::gather(
    key   = "Census"
    , value = "Population"
    , -Province, - Division
  )

ggplot(
  data = plotUnit
  , mapping = aes(x = reorder(Division, -Population), y = Population, fill = Census)) +
  geom_bar(stat = "identity", position = position_dodge(width = .9))+
  scale_y_continuous(labels= scales::comma, expand =  c(0, 0)) +
  scale_x_discrete(expand = c(0.03,0))+
  geom_text(aes(label=scales::comma(Population)),
            position=position_dodge(width = 0.9), vjust = 0.8) +
  facet_wrap(~Province, scales = "free_x") +
  labs(x = "Divisions") +
  theme(legend.position = "top")
}

tableOut <- function(type) {
  if(type == "Provinces"){
    adminUnit <-
      PakPC2017Tehsil %>%
      dplyr::group_by(Province) %>%
      dplyr::summarize(
          Pop2017 = sum(Pop2017, na.rm = TRUE)
        , Pop1998 = sum(Pop1998, na.rm = TRUE)
      )
    adminUnit
  }
  else if(type == "Divisions"){
    adminUnit <-
      PakPC2017Tehsil %>%
      dplyr::group_by(Province, Division) %>%
      dplyr::summarize(
        Pop2017 = sum(Pop2017, na.rm = TRUE)
        , Pop1998 = sum(Pop1998, na.rm = TRUE)
      )
    adminUnit
  }
  else if(type == "Districts"){
    adminUnit <-
      PakPC2017Tehsil %>%
      dplyr::group_by(Province, Division, District) %>%
      dplyr::summarize(
        Pop2017 = sum(Pop2017, na.rm = TRUE)
        , Pop1998 = sum(Pop1998, na.rm = TRUE)
      )
    adminUnit
  }
  else if(type == "Tehsils"){
    adminUnit <- PakPC2017Tehsil
    adminUnit
  }
  else{
    adminUnit <- PakPC2017City10
    adminUnit
  }
}

shinyServer(
  function(input, output, session) {
    observe({
      filterDivision <- dplyr::filter(PakPC2017Tehsil, Province %in% input$Province)
      levelDivision <- levels(as.factor(filterDivision$Division))
      updateSelectInput(
        session = session
        , inputId = "Division"
        , choices = c("select division"="", levelDivision)
      )
      reactive(input$Division)
    })

    observe({
      filterDistrict <- dplyr::filter(PakPC2017Tehsil, Division %in% input$Division)
      levelDistrict <- levels(as.factor(filterDistrict$District))
      updateSelectInput(
        session = session
        , inputId = "District"
        , choices = c("select district"="",levelDistrict)
      )
      reactive(input$District)
    })

    observe({
      filterTehsil <- dplyr::filter(PakPC2017Tehsil, District %in% input$District)
      levelTehsil <- levels(as.factor(filterTehsil$Tehsil))
      updateSelectInput(
        session = session
        , inputId = "Tehsil"
        , choices = c("select tehsil"="", levelTehsil)
      )
    })

    adminUnit <-
      reactive(
        {
          tableOut(as.character(input$AdminUnit))
        }
      )

    plotUnit <-
      reactive(
        {
          if(input$PlotUnit=="Provinces"){
            plotProvinces()
          }
          else if(input$PlotUnit=="Divisions"){
            plotDivisions(input$Division)
          }
          else if(input$PlotUnit=="Districts"){
            plotDistricts(input$District)
          }
          else if(input$PlotUnit=="Tehsils"){
            plotTehsils(input$Tehsil)
          }
          else{
            plotCity()
          }
        }
      )
    Population <- readRDS('FSDCity.RDS')
    mapCity<-tm_shape(Population)+
      tm_fill("Popultion", id = "Circle")
    cityMap<-tmap_leaflet(mapCity)
    cityMap2<-cityMap %>%
      addTiles() %>%  # Add default OpenStreetMap map tiles
      addPolygons(data = Population,label = as.character(Population$Circle), color = "#007196", weight = 1, smoothFactor = 0.5,
                  opacity = 0.7, fillOpacity = 0,
                  popup=paste0("<b>Circle Code = </b>",Population$Circle,"<p>Population = ",Population$Popultion,"<br> Households = ",Population$HH," </p>",sep = ""),
                  highlightOptions = highlightOptions(color = "red", weight = 2,
                                                      bringToFront = TRUE))%>%
      addEasyButton(easyButton(
        icon="fa-globe", title="Zoom to Level 1",
        onClick=JS("function(btn, map){ map.setZoom(1); }"))) %>%
      addEasyButton(easyButton(
        icon="fa-crosshairs", title="Locate Me",
        onClick=JS("function(btn, map){ map.locate({setView: true,watch: true}); }")))

    Population2 <- readRDS('PakDist.RDS')
    mapDist<-tm_shape(Population2)+
      tm_polygons("Pop2017", id = "NAME_EN", title = "Population 2017", palette = "YlOrRd", contrast = c(0.21, 0.71),style = "kmeans",n = 7, auto.palette.mapping = FALSE)
    distMap1<-tmap_leaflet(mapDist)
    distMap<-distMap1 %>%
      addTiles() %>%  # Add default OpenStreetMap map tiles
      addPolygons(data = Population2, label = Population2$NAME_EN, color = "#007196", weight = 1, smoothFactor = 0.5,
                  opacity = 0.7, fillOpacity = 0,
                  popup=paste0("<b>District = </b>",Population2$NAME_EN,"<p>Population = ",Population2$Pop2017,"<br> Households = ",Population2$HH," </p>",sep = ""),
                  highlightOptions = highlightOptions(color = "red", weight = 2,
                                                      bringToFront = TRUE))%>%
      addEasyButton(easyButton(
        icon="fa-globe", title="Zoom to Level 1",
        onClick=JS("function(btn, map){ map.setZoom(1); }"))) %>%
      addEasyButton(easyButton(
        icon="fa-crosshairs", title="Locate Me",
        onClick=JS("function(btn, map){ map.locate({setView: true,watch: true}); }")))


    output$geoMap = renderLeaflet(cityMap2)
    output$geoDist = renderLeaflet(distMap)


    output$myTable <- renderDataTable({adminUnit()})

    output$myMap <-
      renderPlot(
        {
          plotUnit()
        }
      )
    output$download_plot.pdf <- downloadHandler(
      filename = function() {
        paste("Figure_ggplotGUI_", Sys.time(), ".pdf", sep = "")
      },
      content <- function(file) {
        ggsave(file, plot = last_plot())
      },
      contentType = "application/pdf" # MIME type of the image
    )
  }
)

#' @title Visualization of selected districts.
#' @name plotDistricts
#' @description Visualization of selected districts from shiny app.
#' @param filterTehsil The selected districts for which plot to be build.
#' @keywords internal
#' @return Return ggplot of selected districts.

if(getRversion() >= "2.15.1"){
  utils::globalVariables(
    c(
      "Census"
      , "City"
      , "District"
      , "Division"
      , "Pop1998"
      , "Pop2017"
      , "Population"
      , "Province"
      , "Tehsil"
    )
  )
}

plotDistricts <- function(filterDistrict) {
  plotUnit <-
    PakPC2017::PakPC2017Tehsil %>%
    dplyr::group_by(Province, Division, District) %>%
    dplyr::summarize(
        Pop2017 = sum(Pop2017, na.rm = TRUE)
      , Pop1998 = sum(Pop1998, na.rm = TRUE)
    ) %>%
    dplyr::filter(District %in% filterDistrict) %>%
    tidyr::gather(
      key   = "Census"
      , value = "Population"
      , -Province, - Division, -District
    )


  ggplot(
    data = plotUnit
    , mapping = aes(x = reorder(District, -Population), y = Population, fill = Census)) +
    geom_bar(stat = "identity", position = position_dodge(width = .9))+
    scale_y_continuous(labels= scales::comma, expand =  c(0, 0)) +
    scale_x_discrete(expand = c(0.03,0))+
    geom_text(aes(label=scales::comma(Population)),
              position=position_dodge(width = 0.9), vjust = 0.8) +
    facet_wrap(~ Province, scales = "free_x") +
    labs(x = "Districts") +
    theme(legend.position = "top")
}

shinyUI(
  fluidPage(
    headerPanel(
      title = "Spatial Analysis of Pakistan Population Census 2017"
    )
    , sidebarPanel(
      width = 3
      , conditionalPanel(
        condition = "input.tabs == 'data'"
        ,  h4("Population by")
        , selectInput(
          inputId = "AdminUnit"
          , label   = "Please Select Admin Unit"
          , choices = c(
            "Provinces"
            , "Divisions"
            , "Districts"
            , "Tehsils"
            , "City"
          )
          , selected ="Provinces"
        )
      )
      , conditionalPanel(
        condition = "input.tabs == 'Plot'"
        ,  h4("Chart by Administrative Unit")
        ,  selectInput(
          inputId = "PlotUnit"
          , label   = "Select Admin Unit"
          , choices = c(
            "Provinces"
            , "Divisions"
            , "Districts"
            , "Tehsils"
            , "Cities"
          )
          , "Provinces"
        )
        , conditionalPanel(
          condition = "input.PlotUnit == 'Divisions'||
          input.PlotUnit == 'Districts'||
          input.PlotUnit == 'Tehsils'"
          ,  selectInput(
            inputId  = "Province"
            , label    = "Select one or more Provinces first"
            , choices  = c("Select Province"="",levels(as.factor(PakPC2017Tehsil$Province)))
            , multiple = TRUE
          )
        )
        , conditionalPanel(
          condition = "input.PlotUnit == 'Divisions'||
          input.PlotUnit == 'Districts'||
          input.PlotUnit == 'Tehsils'"
          , selectInput(
            inputId  = "Division"
            , label    = "Select one or more Divisions"
            , choices  = ""
            , multiple = TRUE
          )
        )
        , conditionalPanel(
          condition = "input.PlotUnit == 'Districts'||
          input.PlotUnit == 'Tehsils'"
          , selectInput(
            inputId  = "District"
            , label    = "Select one or more Districts"
            , choices  = ""
            , multiple = TRUE
          )
        )
        , conditionalPanel(
          condition = "input.PlotUnit == 'Tehsils'"
          ,  selectInput(
            inputId  = "Tehsil"
            , label    = "Select one or more Tehsils"
            , choices  = ""
            , multiple = TRUE
          )
        )
      )


)
, mainPanel(
  width = 9
  , tabsetPanel(
    type = "tabs"
    , tabPanel(
      title = "data"
      , dataTableOutput("myTable")
    )
    , tabPanel(
      title = "Plot"
      , mainPanel(
        width = 12
        , downloadButton(
          outputId = "download_plot.pdf"
          , label    = "Download pdf of figure"
        )
        , plotOutput("myMap")
      )
    )
    ,tabPanel("Geographical Districts", leafletOutput("geoDist"))
    ,tabPanel("Geographical Faisalabad", leafletOutput("geoMap"))
    , id = "tabs"
  )
)
  )

)
